<script>
import axios from 'axios';

import { GlButton, GlProgressBar, GlEmptyState } from '@gitlab/ui';
import { programmingLanguages } from '../../constants';
import CodeResult from '../components/rate_code.vue';
import { getRatedPrompts, markPromptAsRated } from './prompts-rating-store';

function getRandomElement(array) {
  const randomIndex = Math.floor(Math.random() * array.length);
  return array[randomIndex];
}

export default {
  name: 'LanguagePromptTest',
  components: {
    GlButton,
    GlProgressBar,
    GlEmptyState,
    CodeResult,
  },
  asyncData({ params }) {
    const language = params.language;
    return { language };
  },
  data() {
    return {
      promptsData: [],
      promptsVersion: '',
      seenPrompts: [],
      promptToShow: null,
      isSubmitting: false,
    };
  },
  async fetch() {
    const { promptsVersion, promptsData } = await this.$axios.$get(
      `/api/prompts/${this.language}`
    );
    this.promptsData = promptsData;
    this.promptsVersion = promptsVersion;

    this.refreshSeenPrompts();
    this.pickNewPrompt();
  },
  computed: {
    title() {
      return `Please check this prompt for ${this.language} and their results`;
    },
    percentSeen() {
      return Math.floor(
        (this.promptsSeenCount / this.promptsData.length) * 100
      );
    },
    languageHighlightId() {
      return this.$options.programmingLanguages.find(
        (language) => language.id === this.language
      ).highlightId;
    },
    seenPromptsKey() {
      return `${this.language}SeenPrompts`;
    },
    promptsSeenCount() {
      return this.seenPrompts.length;
    },
    isSurveyCompleted() {
      return (
        this.promptsData.length > 0 &&
        this.promptsData.length === this.seenPrompts.length
      );
    },
  },
  programmingLanguages,
  methods: {
    refreshSeenPrompts() {
      this.seenPrompts = getRatedPrompts(this.promptsVersion, this.language);
    },
    pickNewPrompt() {
      this.promptToShow = getRandomElement(
        this.promptsData.filter(
          (prompt) => !this.seenPrompts.includes(prompt.id)
        )
      );
    },
    async onVoteReceived(vote) {
      this.isSubmitting = true;
      try {
        await axios.post(
          `/api/vote/${this.promptToShow.promptResultId}`,
          null,
          {
            params: {
              language: this.language,
              model: this.promptToShow.model,
              option: vote,
            },
          }
        );
        this.switchToNextPrompt();
      } catch (error) {
        if (error) {
          alert('Failed to submit vote');
        }
      } finally {
        this.isSubmitting = false;
      }
    },
    switchToNextPrompt() {
      markPromptAsRated(
        this.promptsVersion,
        this.language,
        this.promptToShow.id
      );
      this.refreshSeenPrompts();
      this.pickNewPrompt();
    },
  },
};
</script>
<template>
  <main
    class="container gl-mt-7 gl-mb-4 gl-display-flex gl-flex-direction-column"
  >
    <h1>{{ title }}</h1>
    <div v-if="promptToShow">
      <gl-progress-bar :value="percentSeen"></gl-progress-bar>
      <div class="gl-display-flex gl-flex-direction-column">
        <div>
          <code-result
            :name="`User input`"
            :language="languageHighlightId"
            :source="promptToShow.prompt"
          />
        </div>
        <div>
          <code-result
            :name="`Generated ${language} code`"
            :language="languageHighlightId"
            :source="promptToShow.generatedCode"
            show-rate-controls
            :is-submitting="isSubmitting"
            @vote="onVoteReceived"
          />
        </div>
      </div>
      <div class="gl--flex-center gl-mt-5">
        <gl-button
          v-if="promptToShow"
          category="primary"
          variant="confirm"
          @click="switchToNextPrompt"
          >Skip to the next prompt</gl-button
        >
      </div>
    </div>
    <gl-empty-state
      v-if="isSurveyCompleted"
      title="Congrats!"
      description=" You've rated all the prompts for this language"
      primary-button-text="Back to language select"
      primary-button-link="/rate-prompts"
    />
  </main>
</template>
